//=============================================================================
//
// file :        GofProfile.h
//
// description : Include for the GofProfile class.
//
// project :	GofProfile
//
// $Author: giulio $ Giulio Gaio
//
// $Revision: 1.2 $ 1.0
//
// $Log: GofProfile.h,v $
// Revision 1.2  2020-02-20 09:02:44  giulio
// Added MeanOrbitHor MeanOrbitVer
//
// Revision 1.1.1.1  2014-10-06 12:24:46  giulio
// First cvs release
//
//
// copyleft :   Sincrotrone Trieste S.C.p.A.
//              Strada Statale 14 - km 163,5 in AREA Science Park
//              34012 Basovizza, Trieste ITALY
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================
#ifndef _GOFPROFILE_H
#define _GOFPROFILE_H

#include <tango.h>
#include <mbf_shm.h>
#include <mbf.h>
#include <gofprofile_shm.h>
//using namespace Tango;

/**
 * @author	$Author: giulio $
 * @version	$Revision: 1.2 $
 */

 //	Add your own constants definitions here.
 //-----------------------------------------------


namespace GofProfile_ns
{

/**
 * Class Description:
 * Profile of gof values: return bpm value and correctors in different orders and modes.
 *	It is principally used for visualization
 */

/*
 *	Device States Description:
 *  Tango::ON :     On if gofprofile module exists
 *  Tango::FAULT :  Fault if gofprofile module isn't installed
 */


class GofProfile: public Tango::Device_4Impl
{
public :
	//	Add your own data members here
	//-----------------------------------------


	//	Here is the Start of the automatic code generation part
	//-------------------------------------------------------------	
/**
 *	@name attributes
 *	Attributs member data.
 */
//@{
		Tango::DevFloat	*attr_OrbitHor_read;
		Tango::DevFloat	*attr_OrbitVer_read;
		Tango::DevShort	*attr_CorrHor_read;
		Tango::DevShort	*attr_CorrVer_read;
		Tango::DevFloat	*attr_OrbitHorFast_read;
		Tango::DevFloat	*attr_OrbitVerFast_read;
		Tango::DevShort	*attr_CorrHorFast_read;
		Tango::DevShort	*attr_CorrVerFast_read;
		Tango::DevFloat	*attr_GofOrbitHor_read;
		Tango::DevFloat	*attr_GofOrbitVer_read;
		Tango::DevFloat	*attr_RelativeOrbitHor_read;
		Tango::DevFloat	*attr_RelativeOrbitVer_read;
		Tango::DevFloat	*attr_RelativeOrbitHorFast_read;
		Tango::DevFloat	*attr_RelativeOrbitVerFast_read;
		Tango::DevFloat	*attr_RelativeOrbitHorHistory_read;
		Tango::DevFloat	*attr_RelativeOrbitVerHistory_read;
		Tango::DevFloat	*attr_RelativeOrbitHorHistoryFast_read;
		Tango::DevFloat	*attr_RelativeOrbitVerHistoryFast_read;
		Tango::DevFloat	*attr_CorrHorHistory_read;
		Tango::DevFloat	*attr_CorrVerHistory_read;
		Tango::DevFloat	*attr_CorrHorHistoryFast_read;
		Tango::DevFloat	*attr_CorrVerHistoryFast_read;
		Tango::DevFloat	*attr_RmsOrbitHor_read;
		Tango::DevFloat	*attr_RmsOrbitVer_read;
		Tango::DevFloat	*attr_RmsCorrHor_read;
		Tango::DevFloat	*attr_RmsCorrVer_read;
		Tango::DevFloat	*attr_OrbitHorHistory_read;
		Tango::DevFloat	*attr_OrbitVerHistory_read;
		Tango::DevFloat	*attr_OrbitHorHistoryFast_read;
		Tango::DevFloat	*attr_OrbitVerHistoryFast_read;
		Tango::DevFloat	*attr_GofRelativeOrbitHor_read;
		Tango::DevFloat	*attr_GofRelativeOrbitVer_read;
		Tango::DevFloat	*attr_CorrHorMaxPerc_read;
		Tango::DevFloat	*attr_CorrVerMaxPerc_read;
		Tango::DevFloat	*attr_MeanRmsOrbitHor_read;
		Tango::DevFloat	*attr_MeanRmsOrbitVer_read;
		Tango::DevFloat	*attr_AbsRmsOrbitHor_read;
		Tango::DevFloat	*attr_AbsRmsOrbitVer_read;
		Tango::DevFloat	*attr_MeanOrbitHor_read;
		Tango::DevFloat	*attr_MeanOrbitVer_read;
		Tango::DevFloat	*attr_ErrRmsOrbitHor_read;
		Tango::DevFloat	*attr_ErrRmsOrbitVer_read;
//@}

/**
 *	@name Device properties
 *	Device properties member data.
 */
//@{
/**
 *	Bpm's not present in orbit profile.
 */
	vector<string>	bpmExcluded;
/**
 *	Corrector excluded from profile
 */
	vector<string>	corrExcluded;
/**
 *	Circluar buffer length is seconds of the slow data profile.
 *	Maximum is 2000 samples
 */
	Tango::DevLong	historyLen;
/**
 *	Circluar buffer length is seconds of the fast data profile.
 *	Maximum is 2000 samples
 */
	Tango::DevLong	fastHistoryLen;
/**
 *	Acquisition frequency for slow data profile
 */
	Tango::DevLong	slowFreq;
/**
 *	Acquisition frequency for fast data profile
 */
	Tango::DevLong	fastFreq;
/**
 *	Number of seconds of fast data used to calculate rms
 */
	Tango::DevLong	rmsLen;
//@}

/**@name Constructors
 * Miscellaneous constructors */
//@{
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	GofProfile(Tango::DeviceClass *cl,string &s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	GofProfile(Tango::DeviceClass *cl,const char *s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device name
 *	@param d	Device description.
 */
	GofProfile(Tango::DeviceClass *cl,const char *s,const char *d);
//@}

/**@name Destructor
 * Only one desctructor is defined for this class */
//@{
/**
 * The object desctructor.
 */	
	~GofProfile() {delete_device();};
/**
 *	will be called at device destruction or at init command.
 */
	void delete_device();
//@}

	
/**@name Miscellaneous methods */
//@{
/**
 *	Initialize the device
 */
	virtual void init_device();
/**
 *	Always executed method befor execution command method.
 */
	virtual void always_executed_hook();

//@}

/**
 * @name GofProfile methods prototypes
 */

//@{
/**
 *	Hardware acquisition for attributes.
 */
	virtual void read_attr_hardware(vector<long> &attr_list);
/**
 *	Extract real attribute values for OrbitHor acquisition result.
 */
	virtual void read_OrbitHor(Tango::Attribute &attr);
/**
 *	Extract real attribute values for OrbitVer acquisition result.
 */
	virtual void read_OrbitVer(Tango::Attribute &attr);
/**
 *	Extract real attribute values for CorrHor acquisition result.
 */
	virtual void read_CorrHor(Tango::Attribute &attr);
/**
 *	Extract real attribute values for CorrVer acquisition result.
 */
	virtual void read_CorrVer(Tango::Attribute &attr);
/**
 *	Extract real attribute values for OrbitHorFast acquisition result.
 */
	virtual void read_OrbitHorFast(Tango::Attribute &attr);
/**
 *	Extract real attribute values for OrbitVerFast acquisition result.
 */
	virtual void read_OrbitVerFast(Tango::Attribute &attr);
/**
 *	Extract real attribute values for CorrHorFast acquisition result.
 */
	virtual void read_CorrHorFast(Tango::Attribute &attr);
/**
 *	Extract real attribute values for CorrVerFast acquisition result.
 */
	virtual void read_CorrVerFast(Tango::Attribute &attr);
/**
 *	Extract real attribute values for GofOrbitHor acquisition result.
 */
	virtual void read_GofOrbitHor(Tango::Attribute &attr);
/**
 *	Extract real attribute values for GofOrbitVer acquisition result.
 */
	virtual void read_GofOrbitVer(Tango::Attribute &attr);
/**
 *	Extract real attribute values for RelativeOrbitHor acquisition result.
 */
	virtual void read_RelativeOrbitHor(Tango::Attribute &attr);
/**
 *	Extract real attribute values for RelativeOrbitVer acquisition result.
 */
	virtual void read_RelativeOrbitVer(Tango::Attribute &attr);
/**
 *	Extract real attribute values for RelativeOrbitHorFast acquisition result.
 */
	virtual void read_RelativeOrbitHorFast(Tango::Attribute &attr);
/**
 *	Extract real attribute values for RelativeOrbitVerFast acquisition result.
 */
	virtual void read_RelativeOrbitVerFast(Tango::Attribute &attr);
/**
 *	Extract real attribute values for RelativeOrbitHorHistory acquisition result.
 */
	virtual void read_RelativeOrbitHorHistory(Tango::Attribute &attr);
/**
 *	Extract real attribute values for RelativeOrbitVerHistory acquisition result.
 */
	virtual void read_RelativeOrbitVerHistory(Tango::Attribute &attr);
/**
 *	Extract real attribute values for RelativeOrbitHorHistoryFast acquisition result.
 */
	virtual void read_RelativeOrbitHorHistoryFast(Tango::Attribute &attr);
/**
 *	Extract real attribute values for RelativeOrbitVerHistoryFast acquisition result.
 */
	virtual void read_RelativeOrbitVerHistoryFast(Tango::Attribute &attr);
/**
 *	Extract real attribute values for CorrHorHistory acquisition result.
 */
	virtual void read_CorrHorHistory(Tango::Attribute &attr);
/**
 *	Extract real attribute values for CorrVerHistory acquisition result.
 */
	virtual void read_CorrVerHistory(Tango::Attribute &attr);
/**
 *	Extract real attribute values for CorrHorHistoryFast acquisition result.
 */
	virtual void read_CorrHorHistoryFast(Tango::Attribute &attr);
/**
 *	Extract real attribute values for CorrVerHistoryFast acquisition result.
 */
	virtual void read_CorrVerHistoryFast(Tango::Attribute &attr);
/**
 *	Extract real attribute values for RmsOrbitHor acquisition result.
 */
	virtual void read_RmsOrbitHor(Tango::Attribute &attr);
/**
 *	Extract real attribute values for RmsOrbitVer acquisition result.
 */
	virtual void read_RmsOrbitVer(Tango::Attribute &attr);
/**
 *	Extract real attribute values for RmsCorrHor acquisition result.
 */
	virtual void read_RmsCorrHor(Tango::Attribute &attr);
/**
 *	Extract real attribute values for RmsCorrVer acquisition result.
 */
	virtual void read_RmsCorrVer(Tango::Attribute &attr);
/**
 *	Extract real attribute values for OrbitHorHistory acquisition result.
 */
	virtual void read_OrbitHorHistory(Tango::Attribute &attr);
/**
 *	Extract real attribute values for OrbitVerHistory acquisition result.
 */
	virtual void read_OrbitVerHistory(Tango::Attribute &attr);
/**
 *	Extract real attribute values for OrbitHorHistoryFast acquisition result.
 */
	virtual void read_OrbitHorHistoryFast(Tango::Attribute &attr);
/**
 *	Extract real attribute values for OrbitVerHistoryFast acquisition result.
 */
	virtual void read_OrbitVerHistoryFast(Tango::Attribute &attr);
/**
 *	Extract real attribute values for GofRelativeOrbitHor acquisition result.
 */
	virtual void read_GofRelativeOrbitHor(Tango::Attribute &attr);
/**
 *	Extract real attribute values for GofRelativeOrbitVer acquisition result.
 */
	virtual void read_GofRelativeOrbitVer(Tango::Attribute &attr);
/**
 *	Extract real attribute values for CorrHorMaxPerc acquisition result.
 */
	virtual void read_CorrHorMaxPerc(Tango::Attribute &attr);
/**
 *	Extract real attribute values for CorrVerMaxPerc acquisition result.
 */
	virtual void read_CorrVerMaxPerc(Tango::Attribute &attr);
/**
 *	Extract real attribute values for MeanRmsOrbitHor acquisition result.
 */
	virtual void read_MeanRmsOrbitHor(Tango::Attribute &attr);
/**
 *	Extract real attribute values for MeanOrbitHor acquisition result.
 */
	virtual void read_MeanOrbitHor(Tango::Attribute &attr);
/**
 *	Extract real attribute values for MeanRmsOrbitVer acquisition result.
 */
	virtual void read_MeanRmsOrbitVer(Tango::Attribute &attr);
/**
 *	Extract real attribute values for MeanRmsOrbitVer acquisition result.
 */
	virtual void read_MeanOrbitVer(Tango::Attribute &attr);
/**
 *	Extract real attribute values for ErrRmsOrbitHor acquisition result.
 */
	virtual void read_ErrRmsOrbitHor(Tango::Attribute &attr);
/**
 *	Extract real attribute values for ErrRmsOrbitVer acquisition result.
 */
	virtual void read_ErrRmsOrbitVer(Tango::Attribute &attr);
/**
 *	Extract real attribute values for AbsRmsOrbitHor acquisition result.
 */
	virtual void read_AbsRmsOrbitHor(Tango::Attribute &attr);
/**
 *	Extract real attribute values for AbsRmsOrbitVer acquisition result.
 */
	virtual void read_AbsRmsOrbitVer(Tango::Attribute &attr);
/**
 *	Read/Write allowed for OrbitHor attribute.
 */
	virtual bool is_OrbitHor_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for OrbitVer attribute.
 */
	virtual bool is_OrbitVer_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for CorrHor attribute.
 */
	virtual bool is_CorrHor_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for CorrVer attribute.
 */
	virtual bool is_CorrVer_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for OrbitHorFast attribute.
 */
	virtual bool is_OrbitHorFast_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for OrbitVerFast attribute.
 */
	virtual bool is_OrbitVerFast_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for CorrHorFast attribute.
 */
	virtual bool is_CorrHorFast_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for CorrVerFast attribute.
 */
	virtual bool is_CorrVerFast_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for GofOrbitHor attribute.
 */
	virtual bool is_GofOrbitHor_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for GofOrbitVer attribute.
 */
	virtual bool is_GofOrbitVer_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for RelativeOrbitHor attribute.
 */
	virtual bool is_RelativeOrbitHor_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for RelativeOrbitVer attribute.
 */
	virtual bool is_RelativeOrbitVer_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for RelativeOrbitHorFast attribute.
 */
	virtual bool is_RelativeOrbitHorFast_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for RelativeOrbitVerFast attribute.
 */
	virtual bool is_RelativeOrbitVerFast_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for RelativeOrbitHorHistory attribute.
 */
	virtual bool is_RelativeOrbitHorHistory_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for RelativeOrbitVerHistory attribute.
 */
	virtual bool is_RelativeOrbitVerHistory_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for RelativeOrbitHorHistoryFast attribute.
 */
	virtual bool is_RelativeOrbitHorHistoryFast_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for RelativeOrbitVerHistoryFast attribute.
 */
	virtual bool is_RelativeOrbitVerHistoryFast_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for CorrHorHistory attribute.
 */
	virtual bool is_CorrHorHistory_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for CorrVerHistory attribute.
 */
	virtual bool is_CorrVerHistory_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for CorrHorHistoryFast attribute.
 */
	virtual bool is_CorrHorHistoryFast_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for CorrVerHistoryFast attribute.
 */
	virtual bool is_CorrVerHistoryFast_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for RmsOrbitHor attribute.
 */
	virtual bool is_RmsOrbitHor_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for RmsOrbitVer attribute.
 */
	virtual bool is_RmsOrbitVer_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for AbsRmsOrbitHor attribute.
 */
	virtual bool is_AbsRmsOrbitHor_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for AbsRmsOrbitVer attribute.
 */
	virtual bool is_AbsRmsOrbitVer_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for RmsCorrHor attribute.
 */
	virtual bool is_RmsCorrHor_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for RmsCorrVer attribute.
 */
	virtual bool is_RmsCorrVer_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for OrbitHorHistory attribute.
 */
	virtual bool is_OrbitHorHistory_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for OrbitVerHistory attribute.
 */
	virtual bool is_OrbitVerHistory_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for OrbitHorHistoryFast attribute.
 */
	virtual bool is_OrbitHorHistoryFast_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for OrbitVerHistoryFast attribute.
 */
	virtual bool is_OrbitVerHistoryFast_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for GofRelativeOrbitHor attribute.
 */
	virtual bool is_GofRelativeOrbitHor_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for GofRelativeOrbitVer attribute.
 */
	virtual bool is_GofRelativeOrbitVer_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for CorrHorMaxPerc attribute.
 */
	virtual bool is_CorrHorMaxPerc_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for CorrVerMaxPerc attribute.
 */
	virtual bool is_CorrVerMaxPerc_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for MeanRmsOrbitHor attribute.
 */
	virtual bool is_MeanRmsOrbitHor_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for MeanOrbitHor attribute.
 */
	virtual bool is_MeanOrbitHor_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for MeanRmsOrbitVer attribute.
 */
	virtual bool is_MeanRmsOrbitVer_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for MeanOrbitVer attribute.
 */
	virtual bool is_MeanOrbitVer_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for ErrRmsOrbitHor attribute.
 */
	virtual bool is_ErrRmsOrbitHor_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for ErrRmsOrbitVer attribute.
 */
	virtual bool is_ErrRmsOrbitVer_allowed(Tango::AttReqType type);
/**
 *	Execution allowed for GetSrCorrNames command.
 */
	virtual bool is_GetSrCorrNames_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for GetSrBpmNames command.
 */
	virtual bool is_GetSrBpmNames_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for GetBpmPosition command.
 */
	virtual bool is_GetBpmPosition_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for GetGofBpmNames command.
 */
	virtual bool is_GetGofBpmNames_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for GetGofCorrNames command.
 */
	virtual bool is_GetGofCorrNames_allowed(const CORBA::Any &any);
/**
 * Get corrector names ordered by position in the storage ring
 *	@return	array of corrector names
 *	@exception DevFailed
 */
	Tango::DevVarStringArray	*get_sr_corr_names();
/**
 * Get bpm names ordered by position in the storage ring
 *	@return	array of bpm names
 *	@exception DevFailed
 */
	Tango::DevVarStringArray	*get_sr_bpm_names();
/**
 * Get longitudinal bpm position in mm starting from section 1.
 *	@return	
 *	@exception DevFailed
 */
	Tango::DevVarLongArray	*get_bpm_position();
/**
 * Get bpm names ordered by global feedback logic
 *	@return	array of bpm names
 *	@exception DevFailed
 */
	Tango::DevVarStringArray	*get_gof_bpm_names();
/**
 * Get corrector names ordered by global feedback logic
 *	@return	array of correctors
 *	@exception DevFailed
 */
	Tango::DevVarStringArray	*get_gof_corr_names();

/**
 *	Read the device properties from database
 */
	 void get_device_property();
//@}

	//	Here is the end of the automatic code generation part
	//-------------------------------------------------------------	



protected :	
	//	Add your own data members here
	//-----------------------------------------	
	char rsn[20];	
	gofprofile_shm_t *gofprofilem;	
	mbf_shm_t *mbfm;

	void get_bpm_corr_names(void);	
	std::map <string, long> bpmname_key;
	std::map <string, long> corrname_key;
	vector<long> bpmstorageringposition;
	vector<string> bpmgofnames,
	               bpmstorageringnames,
								 corrgofnames,
	               corrstorageringnames;
								 
	float bpm_array[GOF_NUM_SECTION*GOF_NUM_BPM_SECTION*GOFPROFILE_STORE_SIZE];				
	float bpm_array_small[GOF_NUM_SECTION*GOF_NUM_BPM_SECTION];				 	
	short corr_array[GOF_NUM_SECTION*GOF_NUM_CORR_SECTION];
	
	short bpm_section_idx[GOF_NUM_SECTION*GOF_NUM_BPM_SECTION],
	      bpm_bpm_idx[GOF_NUM_SECTION*GOF_NUM_BPM_SECTION],
        corr_section_idx[GOF_NUM_SECTION*GOF_NUM_CORR_SECTION],
	      corr_corr_idx[GOF_NUM_SECTION*GOF_NUM_CORR_SECTION];
				
	short bpm_excluded_flag[GOF_NUM_SECTION*GOF_NUM_BPM_SECTION];	
	Tango::DevFloat attr_f_value;

	long set_DevStat(void);

};

}	// namespace_ns

#endif	// _GOFPROFILE_H
