static const char *RcsId     = "$Header: /home/cvsadm/cvsroot/fermi/servers/gofprofile/src/GofProfileClass.cpp,v 1.2 2020-02-20 09:02:44 giulio Exp $";
static const char *TagName   = "$Name:  $";
static const char *HttpServer= "http://www.esrf.fr/computing/cs/tango/tango_doc/ds_doc/";
//+=============================================================================
//
// file :        GofProfileClass.cpp
//
// description : C++ source for the GofProfileClass. A singleton
//               class derived from DeviceClass. It implements the
//               command list and all properties and methods required
//               by the GofProfile once per process.
//
// project :     TANGO Device Server
//
// $Author: giulio $ Giulio Gaio
//
// $Revision: 1.2 $ 1.0
//
// $Log: GofProfileClass.cpp,v $
// Revision 1.2  2020-02-20 09:02:44  giulio
// Added MeanOrbitHor MeanOrbitVer
//
// Revision 1.1.1.1  2014-10-06 12:24:46  giulio
// First cvs release
//
//
// copyleft :   Sincrotrone Trieste S.C.p.A.
//              Strada Statale 14 - km 163,5 in AREA Science Park
//              34012 Basovizza, Trieste ITALY
//
//-=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================


#include <tango.h>

#include <GofProfile.h>
#include <GofProfileClass.h>


namespace GofProfile_ns
{
//+----------------------------------------------------------------------------
//
// method : 		GetGofCorrNamesClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetGofCorrNamesClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetGofCorrNamesClass::execute(): arrived" << endl;

	return insert((static_cast<GofProfile *>(device))->get_gof_corr_names());
}

//+----------------------------------------------------------------------------
//
// method : 		GetGofBpmNamesClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetGofBpmNamesClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetGofBpmNamesClass::execute(): arrived" << endl;

	return insert((static_cast<GofProfile *>(device))->get_gof_bpm_names());
}

//+----------------------------------------------------------------------------
//
// method : 		GetBpmPositionClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetBpmPositionClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetBpmPositionClass::execute(): arrived" << endl;

	return insert((static_cast<GofProfile *>(device))->get_bpm_position());
}

//+----------------------------------------------------------------------------
//
// method : 		GetSrBpmNamesClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetSrBpmNamesClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetSrBpmNamesClass::execute(): arrived" << endl;

	return insert((static_cast<GofProfile *>(device))->get_sr_bpm_names());
}

//+----------------------------------------------------------------------------
//
// method : 		GetSrCorrNamesClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetSrCorrNamesClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetSrCorrNamesClass::execute(): arrived" << endl;

	return insert((static_cast<GofProfile *>(device))->get_sr_corr_names());
}

//
//----------------------------------------------------------------
//	Initialize pointer for singleton pattern
//----------------------------------------------------------------
//
GofProfileClass *GofProfileClass::_instance = NULL;

//+----------------------------------------------------------------------------
//
// method : 		GofProfileClass::GofProfileClass(string &s)
// 
// description : 	constructor for the GofProfileClass
//
// in : - s : The class name
//
//-----------------------------------------------------------------------------
GofProfileClass::GofProfileClass(string &s):DeviceClass(s)
{

	cout2 << "Entering GofProfileClass constructor" << endl;
	get_class_property();
	set_default_property();
	write_class_property();
	
	cout2 << "Leaving GofProfileClass constructor" << endl;

}
//+----------------------------------------------------------------------------
//
// method : 		GofProfileClass::~GofProfileClass()
// 
// description : 	destructor for the GofProfileClass
//
//-----------------------------------------------------------------------------
GofProfileClass::~GofProfileClass()
{
	_instance = NULL;
}

//+----------------------------------------------------------------------------
//
// method : 		GofProfileClass::instance
// 
// description : 	Create the object if not already done. Otherwise, just
//			return a pointer to the object
//
// in : - name : The class name
//
//-----------------------------------------------------------------------------
GofProfileClass *GofProfileClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new GofProfileClass(s);
		}
		catch (bad_alloc)
		{
			throw;
		}		
	}		
	return _instance;
}

GofProfileClass *GofProfileClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}

//+----------------------------------------------------------------------------
//
// method : 		GofProfileClass::command_factory
// 
// description : 	Create the command object(s) and store them in the 
//			command list
//
//-----------------------------------------------------------------------------
void GofProfileClass::command_factory()
{
	command_list.push_back(new GetSrCorrNamesClass("GetSrCorrNames",
		Tango::DEV_VOID, Tango::DEVVAR_STRINGARRAY,
		"",
		"array of corrector names",
		Tango::OPERATOR));
	command_list.push_back(new GetSrBpmNamesClass("GetSrBpmNames",
		Tango::DEV_VOID, Tango::DEVVAR_STRINGARRAY,
		"",
		"array of bpm names",
		Tango::OPERATOR));
	command_list.push_back(new GetBpmPositionClass("GetBpmPosition",
		Tango::DEV_VOID, Tango::DEVVAR_LONGARRAY,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetGofBpmNamesClass("GetGofBpmNames",
		Tango::DEV_VOID, Tango::DEVVAR_STRINGARRAY,
		"",
		"array of bpm names",
		Tango::OPERATOR));
	command_list.push_back(new GetGofCorrNamesClass("GetGofCorrNames",
		Tango::DEV_VOID, Tango::DEVVAR_STRINGARRAY,
		"",
		"array of correctors",
		Tango::OPERATOR));

	//	add polling if any
	for (unsigned int i=0 ; i<command_list.size(); i++)
	{
	}
}

//+----------------------------------------------------------------------------
//
// method : 		GofProfileClass::get_class_property
// 
// description : 	Get the class property for specified name.
//
// in :		string	name : The property name
//
//+----------------------------------------------------------------------------
Tango::DbDatum GofProfileClass::get_class_property(string &prop_name)
{
	for (int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		GofProfileClass::get_default_device_property()
// 
// description : 	Return the default value for device property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum GofProfileClass::get_default_device_property(string &prop_name)
{
	for (int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//+----------------------------------------------------------------------------
//
// method : 		GofProfileClass::get_default_class_property()
// 
// description : 	Return the default value for class property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum GofProfileClass::get_default_class_property(string &prop_name)
{
	for (int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		GofProfileClass::device_factory
// 
// description : 	Create the device object(s) and store them in the 
//			device list
//
// in :		Tango::DevVarStringArray *devlist_ptr : The device name list
//
//-----------------------------------------------------------------------------
void GofProfileClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{

	//	Create all devices.(Automatic code generation)
	//-------------------------------------------------------------
	for (unsigned long i=0 ; i < devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
						
		// Create devices and add it into the device list
		//----------------------------------------------------
		device_list.push_back(new GofProfile(this, (*devlist_ptr)[i]));							 

		// Export device to the outside world
		// Check before if database used.
		//---------------------------------------------
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(device_list.back());
		else
			export_device(device_list.back(), (*devlist_ptr)[i]);
	}
	//	End of Automatic code generation
	//-------------------------------------------------------------

}
//+----------------------------------------------------------------------------
//	Method: GofProfileClass::attribute_factory(vector<Tango::Attr *> &att_list)
//-----------------------------------------------------------------------------
void GofProfileClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	//	Attribute : OrbitHor
	OrbitHorAttrib	*orbit_hor = new OrbitHorAttrib();
	att_list.push_back(orbit_hor);

	//	Attribute : OrbitVer
	OrbitVerAttrib	*orbit_ver = new OrbitVerAttrib();
	att_list.push_back(orbit_ver);

	//	Attribute : CorrHor
	CorrHorAttrib	*corr_hor = new CorrHorAttrib();
	att_list.push_back(corr_hor);

	//	Attribute : CorrVer
	CorrVerAttrib	*corr_ver = new CorrVerAttrib();
	att_list.push_back(corr_ver);

	//	Attribute : OrbitHorFast
	OrbitHorFastAttrib	*orbit_hor_fast = new OrbitHorFastAttrib();
	att_list.push_back(orbit_hor_fast);

	//	Attribute : OrbitVerFast
	OrbitVerFastAttrib	*orbit_ver_fast = new OrbitVerFastAttrib();
	att_list.push_back(orbit_ver_fast);

	//	Attribute : CorrHorFast
	CorrHorFastAttrib	*corr_hor_fast = new CorrHorFastAttrib();
	att_list.push_back(corr_hor_fast);

	//	Attribute : CorrVerFast
	CorrVerFastAttrib	*corr_ver_fast = new CorrVerFastAttrib();
	att_list.push_back(corr_ver_fast);

	//	Attribute : GofOrbitHor
	GofOrbitHorAttrib	*gof_orbit_hor = new GofOrbitHorAttrib();
	att_list.push_back(gof_orbit_hor);

	//	Attribute : GofOrbitVer
	GofOrbitVerAttrib	*gof_orbit_ver = new GofOrbitVerAttrib();
	att_list.push_back(gof_orbit_ver);

	//	Attribute : RelativeOrbitHor
	RelativeOrbitHorAttrib	*relative_orbit_hor = new RelativeOrbitHorAttrib();
	att_list.push_back(relative_orbit_hor);

	//	Attribute : RelativeOrbitVer
	RelativeOrbitVerAttrib	*relative_orbit_ver = new RelativeOrbitVerAttrib();
	att_list.push_back(relative_orbit_ver);

	//	Attribute : RelativeOrbitHorFast
	RelativeOrbitHorFastAttrib	*relative_orbit_hor_fast = new RelativeOrbitHorFastAttrib();
	att_list.push_back(relative_orbit_hor_fast);

	//	Attribute : RelativeOrbitVerFast
	RelativeOrbitVerFastAttrib	*relative_orbit_ver_fast = new RelativeOrbitVerFastAttrib();
	att_list.push_back(relative_orbit_ver_fast);

	//	Attribute : RelativeOrbitHorHistory
	RelativeOrbitHorHistoryAttrib	*relative_orbit_hor_history = new RelativeOrbitHorHistoryAttrib();
	att_list.push_back(relative_orbit_hor_history);

	//	Attribute : RelativeOrbitVerHistory
	RelativeOrbitVerHistoryAttrib	*relative_orbit_ver_history = new RelativeOrbitVerHistoryAttrib();
	att_list.push_back(relative_orbit_ver_history);

	//	Attribute : RelativeOrbitHorHistoryFast
	RelativeOrbitHorHistoryFastAttrib	*relative_orbit_hor_history_fast = new RelativeOrbitHorHistoryFastAttrib();
	att_list.push_back(relative_orbit_hor_history_fast);

	//	Attribute : RelativeOrbitVerHistoryFast
	RelativeOrbitVerHistoryFastAttrib	*relative_orbit_ver_history_fast = new RelativeOrbitVerHistoryFastAttrib();
	att_list.push_back(relative_orbit_ver_history_fast);

	//	Attribute : CorrHorHistory
	CorrHorHistoryAttrib	*corr_hor_history = new CorrHorHistoryAttrib();
	att_list.push_back(corr_hor_history);

	//	Attribute : CorrVerHistory
	CorrVerHistoryAttrib	*corr_ver_history = new CorrVerHistoryAttrib();
	att_list.push_back(corr_ver_history);

	//	Attribute : CorrHorHistoryFast
	CorrHorHistoryFastAttrib	*corr_hor_history_fast = new CorrHorHistoryFastAttrib();
	att_list.push_back(corr_hor_history_fast);

	//	Attribute : CorrVerHistoryFast
	CorrVerHistoryFastAttrib	*corr_ver_history_fast = new CorrVerHistoryFastAttrib();
	Tango::UserDefaultAttrProp	corr_ver_history_fast_prop;
	corr_ver_history_fast_prop.set_label("CorrVerHistoryFast");
	corr_ver_history_fast_prop.set_unit("counts");
	corr_ver_history_fast_prop.set_format("%.1f");
	corr_ver_history_fast->set_default_properties(corr_ver_history_fast_prop);
	att_list.push_back(corr_ver_history_fast);

	//	Attribute : RmsOrbitHor
	RmsOrbitHorAttrib	*rms_orbit_hor = new RmsOrbitHorAttrib();
	Tango::UserDefaultAttrProp	rms_orbit_hor_prop;
	rms_orbit_hor_prop.set_label("RmsOrbitHor");
	rms_orbit_hor_prop.set_unit("nm");
	rms_orbit_hor_prop.set_format("%.1f");
	rms_orbit_hor_prop.set_description("Rms of horizontal orbit.");
	rms_orbit_hor->set_default_properties(rms_orbit_hor_prop);
	att_list.push_back(rms_orbit_hor);

	//	Attribute : RmsOrbitVer
	RmsOrbitVerAttrib	*rms_orbit_ver = new RmsOrbitVerAttrib();
	Tango::UserDefaultAttrProp	rms_orbit_ver_prop;
	rms_orbit_ver_prop.set_label("RmsOrbitVer");
	rms_orbit_ver_prop.set_unit("nm");
	rms_orbit_ver_prop.set_format("%.1f");
	rms_orbit_ver->set_default_properties(rms_orbit_ver_prop);
	att_list.push_back(rms_orbit_ver);

	//	Attribute : RmsCorrHor
	RmsCorrHorAttrib	*rms_corr_hor = new RmsCorrHorAttrib();
	Tango::UserDefaultAttrProp	rms_corr_hor_prop;
	rms_corr_hor_prop.set_label("RmsCorrHor");
	rms_corr_hor_prop.set_unit("counts");
	rms_corr_hor_prop.set_format("%.1f");
	rms_corr_hor_prop.set_description("Rms of horizontal correctors");
	rms_corr_hor->set_default_properties(rms_corr_hor_prop);
	att_list.push_back(rms_corr_hor);

	//	Attribute : RmsCorrVer
	RmsCorrVerAttrib	*rms_corr_ver = new RmsCorrVerAttrib();
	Tango::UserDefaultAttrProp	rms_corr_ver_prop;
	rms_corr_ver_prop.set_label("RmsCorrVer");
	rms_corr_ver_prop.set_unit("counts");
	rms_corr_ver_prop.set_format("%.1f");
	rms_corr_ver_prop.set_description("Rms of vertical correctors");
	rms_corr_ver->set_default_properties(rms_corr_ver_prop);
	att_list.push_back(rms_corr_ver);

	//	Attribute : OrbitHorHistory
	OrbitHorHistoryAttrib	*orbit_hor_history = new OrbitHorHistoryAttrib();
	att_list.push_back(orbit_hor_history);

	//	Attribute : OrbitVerHistory
	OrbitVerHistoryAttrib	*orbit_ver_history = new OrbitVerHistoryAttrib();
	att_list.push_back(orbit_ver_history);

	//	Attribute : OrbitHorHistoryFast
	OrbitHorHistoryFastAttrib	*orbit_hor_history_fast = new OrbitHorHistoryFastAttrib();
	att_list.push_back(orbit_hor_history_fast);

	//	Attribute : OrbitVerHistoryFast
	OrbitVerHistoryFastAttrib	*orbit_ver_history_fast = new OrbitVerHistoryFastAttrib();
	att_list.push_back(orbit_ver_history_fast);

	//	Attribute : GofRelativeOrbitHor
	GofRelativeOrbitHorAttrib	*gof_relative_orbit_hor = new GofRelativeOrbitHorAttrib();
	att_list.push_back(gof_relative_orbit_hor);

	//	Attribute : GofRelativeOrbitVer
	GofRelativeOrbitVerAttrib	*gof_relative_orbit_ver = new GofRelativeOrbitVerAttrib();
	att_list.push_back(gof_relative_orbit_ver);

	//	Attribute : CorrHorMaxPerc
	CorrHorMaxPercAttrib	*corr_hor_max_perc = new CorrHorMaxPercAttrib();
	Tango::UserDefaultAttrProp	corr_hor_max_perc_prop;
	corr_hor_max_perc_prop.set_label("CorrHorMaxPerc");
	corr_hor_max_perc_prop.set_format("%.1f");
	corr_hor_max_perc_prop.set_description("Maximum horizontal corrector value in percentage");
	corr_hor_max_perc->set_default_properties(corr_hor_max_perc_prop);
	att_list.push_back(corr_hor_max_perc);

	//	Attribute : CorrVerMaxPerc
	CorrVerMaxPercAttrib	*corr_ver_max_perc = new CorrVerMaxPercAttrib();
	Tango::UserDefaultAttrProp	corr_ver_max_perc_prop;
	corr_ver_max_perc_prop.set_label("CorrVerMaxPerc");
	corr_ver_max_perc_prop.set_format("%.1f");
	corr_ver_max_perc_prop.set_description("Maximum vertical corrector value in percentage");
	corr_ver_max_perc->set_default_properties(corr_ver_max_perc_prop);
	att_list.push_back(corr_ver_max_perc);

	//	Attribute : MeanRmsOrbitHor
	MeanRmsOrbitHorAttrib	*mean_rms_orbit_hor = new MeanRmsOrbitHorAttrib();
	Tango::UserDefaultAttrProp	mean_rms_orbit_hor_prop;
	mean_rms_orbit_hor_prop.set_label("MeanRmsOrbitHor");
	mean_rms_orbit_hor_prop.set_unit("um");
	mean_rms_orbit_hor_prop.set_standard_unit("1");
	mean_rms_orbit_hor_prop.set_display_unit("um");
	mean_rms_orbit_hor_prop.set_format("%.1f");
	mean_rms_orbit_hor_prop.set_description("Mean of the horizontal rms of bpm's");
	mean_rms_orbit_hor->set_default_properties(mean_rms_orbit_hor_prop);
	att_list.push_back(mean_rms_orbit_hor);

	//	Attribute : MeanOrbitHor
	MeanOrbitHorAttrib	*mean_orbit_hor = new MeanOrbitHorAttrib();
	Tango::UserDefaultAttrProp	mean_orbit_hor_prop;
	mean_orbit_hor_prop.set_label("MeanOrbitHor");
	mean_orbit_hor_prop.set_unit("mm");
	mean_orbit_hor_prop.set_format("%.5e");
	mean_orbit_hor_prop.set_description("Average of horizontal orbit");
	mean_orbit_hor->set_default_properties(mean_orbit_hor_prop);
	att_list.push_back(mean_orbit_hor);

	//	Attribute : MeanRmsOrbitVer
	MeanRmsOrbitVerAttrib	*mean_rms_orbit_ver = new MeanRmsOrbitVerAttrib();
	Tango::UserDefaultAttrProp	mean_rms_orbit_ver_prop;
	mean_rms_orbit_ver_prop.set_label("MeanRmsOrbitVer");
	mean_rms_orbit_ver_prop.set_unit("um");
	mean_rms_orbit_ver_prop.set_display_unit("um");
	mean_rms_orbit_ver_prop.set_format("%.1f");
	mean_rms_orbit_ver_prop.set_description("Mean of the vertical rms of bpm's");
	mean_rms_orbit_ver->set_default_properties(mean_rms_orbit_ver_prop);
	att_list.push_back(mean_rms_orbit_ver);

	//	Attribute : MeanOrbitVer
	MeanOrbitVerAttrib	*mean_orbit_ver = new MeanOrbitVerAttrib();
	Tango::UserDefaultAttrProp	mean_orbit_ver_prop;
	mean_orbit_ver_prop.set_label("MeanOrbitVer");
	mean_orbit_ver_prop.set_unit("mm");
	mean_orbit_ver_prop.set_format("%.5e");
	mean_orbit_ver_prop.set_description("Average of vertical orbit");
	mean_orbit_ver->set_default_properties(mean_orbit_ver_prop);
	att_list.push_back(mean_orbit_ver);

	//	Attribute : ErrRmsOrbitHor
	ErrRmsOrbitHorAttrib	*err_rms_orbit_hor = new ErrRmsOrbitHorAttrib();
	Tango::UserDefaultAttrProp	err_rms_orbit_hor_prop;
	err_rms_orbit_hor_prop.set_label("ErrRmsOrbitHor");
	err_rms_orbit_hor_prop.set_unit("um");
	err_rms_orbit_hor_prop.set_display_unit("um");
	err_rms_orbit_hor_prop.set_format("%.1f");
	err_rms_orbit_hor_prop.set_description("Rms of the horizontal orbit error");
	err_rms_orbit_hor->set_default_properties(err_rms_orbit_hor_prop);
	att_list.push_back(err_rms_orbit_hor);

	//	Attribute : AbsRmsOrbitHor
	AbsRmsOrbitHorAttrib	*abs_rms_orbit_hor = new AbsRmsOrbitHorAttrib();
	Tango::UserDefaultAttrProp	abs_rms_orbit_hor_prop;
	abs_rms_orbit_hor_prop.set_label("AbsRmsOrbitHor");
	abs_rms_orbit_hor_prop.set_unit("um");
	abs_rms_orbit_hor_prop.set_display_unit("um");
	abs_rms_orbit_hor_prop.set_format("%.1f");
	abs_rms_orbit_hor_prop.set_description("Abs Rms of the horizontal orbit error");
	abs_rms_orbit_hor->set_default_properties(abs_rms_orbit_hor_prop);
	att_list.push_back(abs_rms_orbit_hor);

	//	Attribute : ErrRmsOrbitVer
	ErrRmsOrbitVerAttrib	*err_rms_orbit_ver = new ErrRmsOrbitVerAttrib();
	Tango::UserDefaultAttrProp	err_rms_orbit_ver_prop;
	err_rms_orbit_ver_prop.set_label("ErrRmsOrbitVer");
	err_rms_orbit_ver_prop.set_unit("um");
	err_rms_orbit_ver_prop.set_display_unit("um");
	err_rms_orbit_ver_prop.set_format("%.1f");
	err_rms_orbit_ver_prop.set_description("Rms of the vertical orbit error");
	err_rms_orbit_ver->set_default_properties(err_rms_orbit_ver_prop);
	att_list.push_back(err_rms_orbit_ver);

	//	Attribute : AbsRmsOrbitVer
	AbsRmsOrbitVerAttrib	*abs_rms_orbit_ver = new AbsRmsOrbitVerAttrib();
	Tango::UserDefaultAttrProp	abs_rms_orbit_ver_prop;
	abs_rms_orbit_ver_prop.set_label("AbsRmsOrbitVer");
	abs_rms_orbit_ver_prop.set_unit("um");
	abs_rms_orbit_ver_prop.set_display_unit("um");
	abs_rms_orbit_ver_prop.set_format("%.1f");
	abs_rms_orbit_ver_prop.set_description("Abs Rms of the vertical orbit error");
	abs_rms_orbit_ver->set_default_properties(abs_rms_orbit_ver_prop);
	att_list.push_back(abs_rms_orbit_ver);

}

//+----------------------------------------------------------------------------
//
// method : 		GofProfileClass::get_class_property()
// 
// description : 	Read the class properties from database.
//
//-----------------------------------------------------------------------------
void GofProfileClass::get_class_property()
{
	//	Initialize your default values here (if not done with  POGO).
	//------------------------------------------------------------------

	//	Read class properties from database.(Automatic code generation)
	//------------------------------------------------------------------

	//	Call database and extract values
	//--------------------------------------------
	if (Tango::Util::instance()->_UseDb==true)
		get_db_class()->get_property(cl_prop);
	Tango::DbDatum	def_prop;
	int	i = -1;


	//	End of Automatic code generation
	//------------------------------------------------------------------

}

//+----------------------------------------------------------------------------
//
// method : 	GofProfileClass::set_default_property
// 
// description: Set default property (class and device) for wizard.
//              For each property, add to wizard property name and description
//              If default value has been set, add it to wizard property and
//              store it in a DbDatum.
//
//-----------------------------------------------------------------------------
void GofProfileClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;

	vector<string>	vect_data;
	//	Set Default Class Properties
	//	Set Default Device Properties
	prop_name = "BpmExcluded";
	prop_desc = "Bpm's not present in orbit profile.";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "CorrExcluded";
	prop_desc = "Corrector excluded from profile";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "HistoryLen";
	prop_desc = "Circluar buffer length is seconds of the slow data profile.\nMaximum is 2000 samples";
	prop_def  = "200";
	vect_data.clear();
	vect_data.push_back("200");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "FastHistoryLen";
	prop_desc = "Circluar buffer length is seconds of the fast data profile.\nMaximum is 2000 samples";
	prop_def  = "1000";
	vect_data.clear();
	vect_data.push_back("1000");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "SlowFreq";
	prop_desc = "Acquisition frequency for slow data profile";
	prop_def  = "1";
	vect_data.clear();
	vect_data.push_back("1");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "FastFreq";
	prop_desc = "Acquisition frequency for fast data profile";
	prop_def  = "10";
	vect_data.clear();
	vect_data.push_back("10");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "RmsLen";
	prop_desc = "Number of seconds of fast data used to calculate rms";
	prop_def  = "1";
	vect_data.clear();
	vect_data.push_back("1");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

}
//+----------------------------------------------------------------------------
//
// method : 		GofProfileClass::write_class_property
// 
// description : 	Set class description as property in database
//
//-----------------------------------------------------------------------------
void GofProfileClass::write_class_property()
{
	//	First time, check if database used
	//--------------------------------------------
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("GofProfile");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("Profile of gof values: return bpm value and correctors in different orders and modes.");
	str_desc.push_back("It is principally used for visualization");
	description << str_desc;
	data.push_back(description);
		
	//	put cvs location
	string	rcsId(RcsId);
	string	filename(classname);
	start = rcsId.find("/");
	if (start!=string::npos)
	{
		filename += "Class.cpp";
		end   = rcsId.find(filename);
		if (end>start)
		{
			string	strloc = rcsId.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}

	//	Get CVS tag revision
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("Device_4Impl");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	//--------------------------------------------
	get_db_class()->put_property(data);
}

}	// namespace
