//=============================================================================
//
// file :         GofProfileClass.h
//
// description :  Include for the GofProfileClass root class.
//                This class is represents the singleton class for
//                the GofProfile device class.
//                It contains all properties and methods which the 
//                GofProfile requires only once e.g. the commands.
//			
// project :      TANGO Device Server
//
// $Author: giulio $ Giulio Gaio
//
// $Revision: 1.2 $ 1.0
//
// $Log: GofProfileClass.h,v $
// Revision 1.2  2020-02-20 09:02:44  giulio
// Added MeanOrbitHor MeanOrbitVer
//
// Revision 1.1.1.1  2014-10-06 12:24:46  giulio
// First cvs release
//
//
// copyleft :   Sincrotrone Trieste S.C.p.A.
//              Strada Statale 14 - km 163,5 in AREA Science Park
//              34012 Basovizza, Trieste ITALY
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================

#ifndef _GOFPROFILECLASS_H
#define _GOFPROFILECLASS_H

#include <tango.h>
#include <GofProfile.h>


namespace GofProfile_ns
{
//=====================================
//	Define classes for attributes
//=====================================
class ErrRmsOrbitVerAttrib: public Tango::Attr
{
public:
	ErrRmsOrbitVerAttrib():Attr("ErrRmsOrbitVer", Tango::DEV_FLOAT, Tango::READ) {};
	~ErrRmsOrbitVerAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_ErrRmsOrbitVer(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_ErrRmsOrbitVer_allowed(ty);}
};

class AbsRmsOrbitVerAttrib: public Tango::Attr
{
public:
	AbsRmsOrbitVerAttrib():Attr("AbsRmsOrbitVer", Tango::DEV_FLOAT, Tango::READ) {};
	~AbsRmsOrbitVerAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_AbsRmsOrbitVer(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_AbsRmsOrbitVer_allowed(ty);}
};

class ErrRmsOrbitHorAttrib: public Tango::Attr
{
public:
	ErrRmsOrbitHorAttrib():Attr("ErrRmsOrbitHor", Tango::DEV_FLOAT, Tango::READ) {};
	~ErrRmsOrbitHorAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_ErrRmsOrbitHor(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_ErrRmsOrbitHor_allowed(ty);}
};

class AbsRmsOrbitHorAttrib: public Tango::Attr
{
public:
	AbsRmsOrbitHorAttrib():Attr("AbsRmsOrbitHor", Tango::DEV_FLOAT, Tango::READ) {};
	~AbsRmsOrbitHorAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_AbsRmsOrbitHor(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_AbsRmsOrbitHor_allowed(ty);}
};

class MeanRmsOrbitVerAttrib: public Tango::Attr
{
public:
	MeanRmsOrbitVerAttrib():Attr("MeanRmsOrbitVer", Tango::DEV_FLOAT, Tango::READ) {};
	~MeanRmsOrbitVerAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_MeanRmsOrbitVer(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_MeanRmsOrbitVer_allowed(ty);}
};

class MeanOrbitVerAttrib: public Tango::Attr
{
public:
	MeanOrbitVerAttrib():Attr("MeanOrbitVer", Tango::DEV_FLOAT, Tango::READ) {};
	~MeanOrbitVerAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_MeanOrbitVer(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_MeanOrbitVer_allowed(ty);}
};

class MeanRmsOrbitHorAttrib: public Tango::Attr
{
public:
	MeanRmsOrbitHorAttrib():Attr("MeanRmsOrbitHor", Tango::DEV_FLOAT, Tango::READ) {};
	~MeanRmsOrbitHorAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_MeanRmsOrbitHor(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_MeanRmsOrbitHor_allowed(ty);}
};

class MeanOrbitHorAttrib: public Tango::Attr
{
public:
	MeanOrbitHorAttrib():Attr("MeanOrbitHor", Tango::DEV_FLOAT, Tango::READ) {};
	~MeanOrbitHorAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_MeanOrbitHor(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_MeanOrbitHor_allowed(ty);}
};

class CorrVerMaxPercAttrib: public Tango::Attr
{
public:
	CorrVerMaxPercAttrib():Attr("CorrVerMaxPerc", Tango::DEV_FLOAT, Tango::READ) {};
	~CorrVerMaxPercAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_CorrVerMaxPerc(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_CorrVerMaxPerc_allowed(ty);}
};

class CorrHorMaxPercAttrib: public Tango::Attr
{
public:
	CorrHorMaxPercAttrib():Attr("CorrHorMaxPerc", Tango::DEV_FLOAT, Tango::READ) {};
	~CorrHorMaxPercAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_CorrHorMaxPerc(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_CorrHorMaxPerc_allowed(ty);}
};

class GofRelativeOrbitVerAttrib: public Tango::SpectrumAttr
{
public:
	GofRelativeOrbitVerAttrib():SpectrumAttr("GofRelativeOrbitVer", Tango::DEV_FLOAT, Tango::READ, 144) {};
	~GofRelativeOrbitVerAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_GofRelativeOrbitVer(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_GofRelativeOrbitVer_allowed(ty);}
};

class GofRelativeOrbitHorAttrib: public Tango::SpectrumAttr
{
public:
	GofRelativeOrbitHorAttrib():SpectrumAttr("GofRelativeOrbitHor", Tango::DEV_FLOAT, Tango::READ, 144) {};
	~GofRelativeOrbitHorAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_GofRelativeOrbitHor(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_GofRelativeOrbitHor_allowed(ty);}
};

class OrbitVerHistoryFastAttrib: public Tango::ImageAttr
{
public:
	OrbitVerHistoryFastAttrib():ImageAttr("OrbitVerHistoryFast", Tango::DEV_FLOAT, Tango::READ, 2000, 144) {};
	~OrbitVerHistoryFastAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_OrbitVerHistoryFast(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_OrbitVerHistoryFast_allowed(ty);}
};

class OrbitHorHistoryFastAttrib: public Tango::ImageAttr
{
public:
	OrbitHorHistoryFastAttrib():ImageAttr("OrbitHorHistoryFast", Tango::DEV_FLOAT, Tango::READ, 2000, 144) {};
	~OrbitHorHistoryFastAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_OrbitHorHistoryFast(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_OrbitHorHistoryFast_allowed(ty);}
};

class OrbitVerHistoryAttrib: public Tango::ImageAttr
{
public:
	OrbitVerHistoryAttrib():ImageAttr("OrbitVerHistory", Tango::DEV_FLOAT, Tango::READ, 2000, 144) {};
	~OrbitVerHistoryAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_OrbitVerHistory(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_OrbitVerHistory_allowed(ty);}
};

class OrbitHorHistoryAttrib: public Tango::ImageAttr
{
public:
	OrbitHorHistoryAttrib():ImageAttr("OrbitHorHistory", Tango::DEV_FLOAT, Tango::READ, 2000, 144) {};
	~OrbitHorHistoryAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_OrbitHorHistory(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_OrbitHorHistory_allowed(ty);}
};

class RmsCorrVerAttrib: public Tango::SpectrumAttr
{
public:
	RmsCorrVerAttrib():SpectrumAttr("RmsCorrVer", Tango::DEV_FLOAT, Tango::READ, 84) {};
	~RmsCorrVerAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_RmsCorrVer(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_RmsCorrVer_allowed(ty);}
};

class RmsCorrHorAttrib: public Tango::SpectrumAttr
{
public:
	RmsCorrHorAttrib():SpectrumAttr("RmsCorrHor", Tango::DEV_FLOAT, Tango::READ, 84) {};
	~RmsCorrHorAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_RmsCorrHor(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_RmsCorrHor_allowed(ty);}
};

class RmsOrbitVerAttrib: public Tango::SpectrumAttr
{
public:
	RmsOrbitVerAttrib():SpectrumAttr("RmsOrbitVer", Tango::DEV_FLOAT, Tango::READ, 144) {};
	~RmsOrbitVerAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_RmsOrbitVer(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_RmsOrbitVer_allowed(ty);}
};

class RmsOrbitHorAttrib: public Tango::SpectrumAttr
{
public:
	RmsOrbitHorAttrib():SpectrumAttr("RmsOrbitHor", Tango::DEV_FLOAT, Tango::READ, 144) {};
	~RmsOrbitHorAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_RmsOrbitHor(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_RmsOrbitHor_allowed(ty);}
};

class CorrVerHistoryFastAttrib: public Tango::ImageAttr
{
public:
	CorrVerHistoryFastAttrib():ImageAttr("CorrVerHistoryFast", Tango::DEV_FLOAT, Tango::READ, 2000, 84) {};
	~CorrVerHistoryFastAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_CorrVerHistoryFast(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_CorrVerHistoryFast_allowed(ty);}
};

class CorrHorHistoryFastAttrib: public Tango::ImageAttr
{
public:
	CorrHorHistoryFastAttrib():ImageAttr("CorrHorHistoryFast", Tango::DEV_FLOAT, Tango::READ, 2000, 84) {};
	~CorrHorHistoryFastAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_CorrHorHistoryFast(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_CorrHorHistoryFast_allowed(ty);}
};

class CorrVerHistoryAttrib: public Tango::ImageAttr
{
public:
	CorrVerHistoryAttrib():ImageAttr("CorrVerHistory", Tango::DEV_FLOAT, Tango::READ, 2000, 84) {};
	~CorrVerHistoryAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_CorrVerHistory(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_CorrVerHistory_allowed(ty);}
};

class CorrHorHistoryAttrib: public Tango::ImageAttr
{
public:
	CorrHorHistoryAttrib():ImageAttr("CorrHorHistory", Tango::DEV_FLOAT, Tango::READ, 2000, 84) {};
	~CorrHorHistoryAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_CorrHorHistory(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_CorrHorHistory_allowed(ty);}
};

class RelativeOrbitVerHistoryFastAttrib: public Tango::ImageAttr
{
public:
	RelativeOrbitVerHistoryFastAttrib():ImageAttr("RelativeOrbitVerHistoryFast", Tango::DEV_FLOAT, Tango::READ, 2000, 144) {};
	~RelativeOrbitVerHistoryFastAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_RelativeOrbitVerHistoryFast(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_RelativeOrbitVerHistoryFast_allowed(ty);}
};

class RelativeOrbitHorHistoryFastAttrib: public Tango::ImageAttr
{
public:
	RelativeOrbitHorHistoryFastAttrib():ImageAttr("RelativeOrbitHorHistoryFast", Tango::DEV_FLOAT, Tango::READ, 2000, 144) {};
	~RelativeOrbitHorHistoryFastAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_RelativeOrbitHorHistoryFast(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_RelativeOrbitHorHistoryFast_allowed(ty);}
};

class RelativeOrbitVerHistoryAttrib: public Tango::ImageAttr
{
public:
	RelativeOrbitVerHistoryAttrib():ImageAttr("RelativeOrbitVerHistory", Tango::DEV_FLOAT, Tango::READ, 2000, 144) {};
	~RelativeOrbitVerHistoryAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_RelativeOrbitVerHistory(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_RelativeOrbitVerHistory_allowed(ty);}
};

class RelativeOrbitHorHistoryAttrib: public Tango::ImageAttr
{
public:
	RelativeOrbitHorHistoryAttrib():ImageAttr("RelativeOrbitHorHistory", Tango::DEV_FLOAT, Tango::READ, 2000, 144) {};
	~RelativeOrbitHorHistoryAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_RelativeOrbitHorHistory(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_RelativeOrbitHorHistory_allowed(ty);}
};

class RelativeOrbitVerFastAttrib: public Tango::SpectrumAttr
{
public:
	RelativeOrbitVerFastAttrib():SpectrumAttr("RelativeOrbitVerFast", Tango::DEV_FLOAT, Tango::READ, 144) {};
	~RelativeOrbitVerFastAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_RelativeOrbitVerFast(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_RelativeOrbitVerFast_allowed(ty);}
};

class RelativeOrbitHorFastAttrib: public Tango::SpectrumAttr
{
public:
	RelativeOrbitHorFastAttrib():SpectrumAttr("RelativeOrbitHorFast", Tango::DEV_FLOAT, Tango::READ, 144) {};
	~RelativeOrbitHorFastAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_RelativeOrbitHorFast(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_RelativeOrbitHorFast_allowed(ty);}
};

class RelativeOrbitVerAttrib: public Tango::SpectrumAttr
{
public:
	RelativeOrbitVerAttrib():SpectrumAttr("RelativeOrbitVer", Tango::DEV_FLOAT, Tango::READ, 144) {};
	~RelativeOrbitVerAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_RelativeOrbitVer(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_RelativeOrbitVer_allowed(ty);}
};

class RelativeOrbitHorAttrib: public Tango::SpectrumAttr
{
public:
	RelativeOrbitHorAttrib():SpectrumAttr("RelativeOrbitHor", Tango::DEV_FLOAT, Tango::READ, 144) {};
	~RelativeOrbitHorAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_RelativeOrbitHor(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_RelativeOrbitHor_allowed(ty);}
};

class GofOrbitVerAttrib: public Tango::SpectrumAttr
{
public:
	GofOrbitVerAttrib():SpectrumAttr("GofOrbitVer", Tango::DEV_FLOAT, Tango::READ, 144) {};
	~GofOrbitVerAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_GofOrbitVer(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_GofOrbitVer_allowed(ty);}
};

class GofOrbitHorAttrib: public Tango::SpectrumAttr
{
public:
	GofOrbitHorAttrib():SpectrumAttr("GofOrbitHor", Tango::DEV_FLOAT, Tango::READ, 144) {};
	~GofOrbitHorAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_GofOrbitHor(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_GofOrbitHor_allowed(ty);}
};

class CorrVerFastAttrib: public Tango::SpectrumAttr
{
public:
	CorrVerFastAttrib():SpectrumAttr("CorrVerFast", Tango::DEV_SHORT, Tango::READ, 100) {};
	~CorrVerFastAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_CorrVerFast(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_CorrVerFast_allowed(ty);}
};

class CorrHorFastAttrib: public Tango::SpectrumAttr
{
public:
	CorrHorFastAttrib():SpectrumAttr("CorrHorFast", Tango::DEV_SHORT, Tango::READ, 100) {};
	~CorrHorFastAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_CorrHorFast(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_CorrHorFast_allowed(ty);}
};

class OrbitVerFastAttrib: public Tango::SpectrumAttr
{
public:
	OrbitVerFastAttrib():SpectrumAttr("OrbitVerFast", Tango::DEV_FLOAT, Tango::READ, 144) {};
	~OrbitVerFastAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_OrbitVerFast(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_OrbitVerFast_allowed(ty);}
};

class OrbitHorFastAttrib: public Tango::SpectrumAttr
{
public:
	OrbitHorFastAttrib():SpectrumAttr("OrbitHorFast", Tango::DEV_FLOAT, Tango::READ, 144) {};
	~OrbitHorFastAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_OrbitHorFast(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_OrbitHorFast_allowed(ty);}
};

class CorrVerAttrib: public Tango::SpectrumAttr
{
public:
	CorrVerAttrib():SpectrumAttr("CorrVer", Tango::DEV_SHORT, Tango::READ, 100) {};
	~CorrVerAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_CorrVer(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_CorrVer_allowed(ty);}
};

class CorrHorAttrib: public Tango::SpectrumAttr
{
public:
	CorrHorAttrib():SpectrumAttr("CorrHor", Tango::DEV_SHORT, Tango::READ, 100) {};
	~CorrHorAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_CorrHor(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_CorrHor_allowed(ty);}
};

class OrbitVerAttrib: public Tango::SpectrumAttr
{
public:
	OrbitVerAttrib():SpectrumAttr("OrbitVer", Tango::DEV_FLOAT, Tango::READ, 144) {};
	~OrbitVerAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_OrbitVer(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_OrbitVer_allowed(ty);}
};

class OrbitHorAttrib: public Tango::SpectrumAttr
{
public:
	OrbitHorAttrib():SpectrumAttr("OrbitHor", Tango::DEV_FLOAT, Tango::READ, 144) {};
	~OrbitHorAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<GofProfile *>(dev))->read_OrbitHor(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<GofProfile *>(dev))->is_OrbitHor_allowed(ty);}
};

//=========================================
//	Define classes for commands
//=========================================
class GetGofCorrNamesClass : public Tango::Command
{
public:
	GetGofCorrNamesClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetGofCorrNamesClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetGofCorrNamesClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<GofProfile *>(dev))->is_GetGofCorrNames_allowed(any);}
};



class GetGofBpmNamesClass : public Tango::Command
{
public:
	GetGofBpmNamesClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetGofBpmNamesClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetGofBpmNamesClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<GofProfile *>(dev))->is_GetGofBpmNames_allowed(any);}
};



class GetBpmPositionClass : public Tango::Command
{
public:
	GetBpmPositionClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetBpmPositionClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetBpmPositionClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<GofProfile *>(dev))->is_GetBpmPosition_allowed(any);}
};



class GetSrBpmNamesClass : public Tango::Command
{
public:
	GetSrBpmNamesClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetSrBpmNamesClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetSrBpmNamesClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<GofProfile *>(dev))->is_GetSrBpmNames_allowed(any);}
};



class GetSrCorrNamesClass : public Tango::Command
{
public:
	GetSrCorrNamesClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetSrCorrNamesClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetSrCorrNamesClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<GofProfile *>(dev))->is_GetSrCorrNames_allowed(any);}
};



//
// The GofProfileClass singleton definition
//

class GofProfileClass : public Tango::DeviceClass
{
public:
//	properties member data

//	add your own data members here
//------------------------------------

public:
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static GofProfileClass *init(const char *);
	static GofProfileClass *instance();
	~GofProfileClass();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	GofProfileClass(string &);
	static GofProfileClass *_instance;
	void command_factory();
	void get_class_property();
	void attribute_factory(vector<Tango::Attr *> &);
	void write_class_property();
	void set_default_property();

private:
	void device_factory(const Tango::DevVarStringArray *);
};


}	//	namespace GofProfile_ns

#endif // _GOFPROFILECLASS_H
