static const char *RcsId = "$Header: /home/cvsadm/cvsroot/fermi/servers/gofprofile/src/main.cpp,v 1.1.1.1 2014-10-06 12:24:46 giulio Exp $";
//+=============================================================================
//
// file :        main.cpp
//
// description : C++ source for a TANGO device server main.
//               The main rule is to initialise (and create) the Tango
//               system and to create the DServerClass singleton.
//               The main should be the same for every Tango device server.
//
// project :     TANGO Device Server
//
// $Author: giulio $ Giulio Gaio
//
// $Revision: 1.1.1.1 $ 1.0
//
// $Log: main.cpp,v $
// Revision 1.1.1.1  2014-10-06 12:24:46  giulio
// First cvs release
//
//
// copyleft :   Sincrotrone Trieste S.C.p.A.
//              Strada Statale 14 - km 163,5 in AREA Science Park
//              34012 Basovizza, Trieste ITALY
//
//-=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================

#include <tango.h>
#include <gofprofile.h>

// rtai shared memories are allocated in main
// to avoid freeing problems
unsigned long shm_dev = 0;
unsigned long mbf_shm_dev = 0;

int main(int argc,char *argv[])
{
	
	gofprofile_init_shmem(&shm_dev,&mbf_shm_dev);
	
	Tango::Util *tg;

	Tango::Util::_daemon = true;
	Tango::Util::_sleep_between_connect = 10;	
	
	try
	{
		// Initialise the device server
		//----------------------------------------
		tg = Tango::Util::init(argc,argv);

		// Create the device server singleton 
		//	which will create everything
		//----------------------------------------
		tg->server_init(false);

		// Run the endless loop
		//----------------------------------------
		cout << "Ready to accept request" << endl;
		tg->server_run();
	}
	catch (bad_alloc)
	{
		cout << "Can't allocate memory to store device object !!!" << endl;
		cout << "Exiting" << endl;
	}
	catch (CORBA::Exception &e)
	{
		Tango::Except::print_exception(e);
		
		cout << "Received a CORBA_Exception" << endl;
		cout << "Exiting" << endl;
	}
	tg->server_cleanup();

	gofprofile_cleanup_shmem(&shm_dev,&mbf_shm_dev);	
	
	return(0);
}
